unit UnidadMenuPrincipal;

{$R WinXP.res}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, DBCtrls, Grids, DBGrids, ExtCtrls,
  shellapi, ZConnection, DB, ZAbstractRODataset, ZAbstractDataset, ZDataset,
  inifiles, aes, base64, StrUtils, ThemeMgr;

type
  TformMenuPrincipal = class(TForm)
    LWEB: TLabel;
    bd: TZConnection;
    tc: TZQuery;
    tcCampos: TZQuery;
    dbTC: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    tab: TPageControl;
    tabConexion: TTabSheet;
    GroupBox11: TGroupBox;
    Label3: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    lContra1: TLabel;
    lContra2: TLabel;
    Label2: TLabel;
    Label14: TLabel;
    txtBDMySQLNombreBD: TEdit;
    txtBDMySQLServidor: TEdit;
    txtBDMySQLUsuario: TEdit;
    txtBDMySQLContrasena: TEdit;
    txtBDMySQLContrasena2: TEdit;
    txtMySQLProtocolo: TComboBox;
    txtMySQLPuerto: TEdit;
    btConectar: TBitBtn;
    GroupBox1: TGroupBox;
    lsTablas: TListBox;
    Panel3: TPanel;
    Label4: TLabel;
    txtValorBuscar: TEdit;
    btIniciarBusqueda: TBitBtn;
    Panel4: TPanel;
    Label5: TLabel;
    tabResultado: TTabSheet;
    tabTablas: TPageControl;
    be: TStatusBar;
    bp: TProgressBar;
    ThemeManager1: TThemeManager;
    procedure LWEBClick(Sender: TObject);
    procedure btConectarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btIniciarBusquedaClick(Sender: TObject);

    function obtenerCamposTexto (tabla : string) : TStringList;

    procedure FormShow(Sender: TObject);
    procedure crearTabTablas (nombreTabla : string; sqlEjecutar : string);
        
  private
    { Private declarations }
    numCoincidencias : integer;
    numTablas : integer;

  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

const
  claveEncriptacionTexto = 'aAdgsxxXr45$nndA.d*dggd2@ddsd';
    
implementation

uses UnidadInfo;

{$R *.dfm}

procedure TformMenuPrincipal.crearTabTablas (nombreTabla : string; sqlEjecutar : string);
var
  tabTmp : TTabSheet;
  gridTmp : TDBGrid;
  dataSTmp : TDataSource;
  navTmp : TDBNavigator;
  tcConsulta : TZReadOnlyQuery;
  etiquetaTmp : TLabel;
begin
  //creamos y ejecutamos la consulta SQL
  tcConsulta := TZReadOnlyQuery.Create(nil);
  tcConsulta.Close;
  tcConsulta.Connection := bd;
  tcConsulta.SQL.Clear;
  tcConsulta.SQL.Add(sqlEjecutar);
  try
    tcConsulta.Open;
  except
    Screen.Cursor := crDefault;
    raise;
  end;
  if tcConsulta.RecordCount > 0 then
  begin
    numCoincidencias := numCoincidencias + tcConsulta.RecordCount;
    numTablas := numTablas + 1;

    //Si se obtienen resultados creamos el TabSheet correspondiente a la tabla
    tabTmp := TTabSheet.Create(tabTablas);
    tabTmp.PageControl := tabTablas;
    tabTmp.Name := 'tabTablas' + inttostr(tabTablas.PageCount);
    tabTmp.Caption := nombreTabla;

    //creamos un Label en la parte inferior del TabSheet para el nmero de coincidencias
    etiquetaTmp := TLabel.Create(nil);
    etiquetaTmp.Align := alBottom;
    etiquetaTmp.Parent := tabTmp;
    etiquetaTmp.Name := 'lbl' + tabTmp.Name;
    etiquetaTmp.Caption := 'Nmero coincidencias tabla ' + nombreTabla + ': ' +
        inttostr(tcConsulta.RecordCount);

    //creamos el DataSource
    dataSTmp := TDataSource.Create(nil);
    dataSTmp.DataSet := tcConsulta;
    dataSTmp.Name := 'dts' + tabTmp.Name;

    //creamos el Navigator
    navTmp := TDBNavigator.Create(nil);
    navTmp.Align := alTop;
    navTmp.Parent := tabTmp;
    navTmp.Flat := true;
    navTmp.VisibleButtons := [nbFirst,nbPrior,nbNext,nbLast,nbRefresh];
    navTmp.Cursor := crHandPoint;
    navTmp.Name := 'nav' + tabTmp.Name;
    navTmp.DataSource := dataSTmp;

    //cremos el DBGrid
    gridTmp := TDBGrid.Create(nil);
    gridTmp.Align := alClient;
    gridTmp.Parent := tabTmp;
    gridTmp.Name := 'grid' + tabTmp.Name;
    gridTmp.DataSource := dataSTmp;

    //mostramos la pestaa (TabSheet)
    tabTmp.Visible := true;
  end
  else
    tcConsulta.Free;
end;


function obtenerSQLConsulta (campos : TStringList;
    tabla : string; valor : string) : string;
var
  sqlT : string;
  camposComa, camposLike : string;
  i : integer;
begin
  Result := '';
  for i := 0 to campos.Count - 1 do
  begin
    if camposComa = '' then
    begin
      camposComa := campos.Strings[i];
      camposLike := campos.Strings[i] + ' LIKE "%' + valor + '%" ';
    end
    else
    begin
      camposComa := camposComa + ', ' + campos.Strings[i];
      camposLike := camposLike + ' or ' + campos.Strings[i] + ' LIKE "%' + valor + '%" ';
    end;
  end;
  sqlT := 'SELECT ' + camposComa + ' FROM ' + tabla + ' WHERE ' + camposLike;
  Result := sqlT;
end;

//escribe un valor string en un fichero INI
procedure esCadINI (clave, cadena : string; valor : String);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteString (clave, cadena, valor);
  finally
    free;
  end;
end;


//lee un valor numrico de un fichero INI
function leNumINI (clave, cadena : string; defecto : Integer) : Integer;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadInteger (clave, cadena, defecto);
  finally
    free;
  end;
end;

//lee un valor string de un fichero INI
function leCadINI (clave, cadena : string; defecto : String) : String;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadString (clave, cadena, defecto);
  finally
    free;
  end;
end;

//escribe un valor numrico en un fichero INI
procedure esNumINI (clave, cadena : string; valor : Integer);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteInteger (clave, cadena, valor);
  finally
    free;
  end;
end;


//encriptar datos
function encriptar (Str, Clave : String) : String;
var
  Src: TStringStream;
  Dst: TMemoryStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result := EmptyStr;
  Src := TStringStream.Create(Str);
  try
    Dst:= TMemoryStream.Create;
    try
      // Preparamos la clave, lo ideal es que tenga 32 caracteres
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AEsExpandKey(ExpandedKey,Key);
      // Guardamos el tamao del texto original
      Size:= Src.Size;
      Dst.WriteBuffer(Size,Sizeof(Size));
      // Ciframos el texto
      AESEncryptStreamECB(Src,Dst,ExpandedKey);
      // Lo codificamos a base64
      Result:= BinToStr(Dst.Memory,Dst.Size);
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

//desencriptar datos
function desencriptar (Str, Clave : String): String;
var
  Src: TMemoryStream;
  Dst: TStringStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result:= EmptyStr;
  Src:= TMemoryStream.Create;
  try
    Dst:= TStringStream.Create(Str);
    try
      StrToStream(Str, Src);
      Src.Position:= 0;
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AESExpandKey(ExpandedKey,Key);
      // Leemos el tamao del texto
      try
        Src.ReadBuffer(Size,Sizeof(Size));
        AESDecryptStreamECB(Src,Dst,ExpandedKey);
        Dst.Size:= Size;
        Result:= Dst.DataString;
      except
        Result := '';
      end;
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.btConectarClick(Sender: TObject);
begin
  bd.Disconnect;
  bd.Port := StrToInt(txtMySQLPuerto.Text);
  bd.HostName := txtBDMySQLServidor.Text;
  bd.Catalog := txtBDMySQLNombreBD.Text;
  bd.Database := txtBDMySQLNombreBD.Text;
  bd.Protocol := txtMySQLProtocolo.Text;
  bd.User := txtBDMySQLUsuario.text;
  bd.Password := txtBDMySQLContrasena.text;
  try
    bd.Connect;
    tc.Close;
    tc.SQL.Clear;
    tc.SQL.Add ('show tables');
    tc.Open;
    while not tc.eof do
    begin
      lsTablas.Items.Add(tc.Fields.Fields[0].AsString);
      tc.Next;
    end;
    tc.Close;
  except
    raise;
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  txtBDMySQLNombreBD.Text := leCadINI('Base de datos', 'Nombre BD', '');
  txtBDMySQLServidor.Text := leCadINI('Base de datos', 'Servidor', 'localhost');
  txtBDMySQLUsuario.Text :=  desencriptar(leCadINI('Base de datos', 'Usuario', ''), claveEncriptacionTexto);
  txtBDMySQLContrasena.Text := desencriptar (leCadINI('Base de datos', 'Contrasea', ''), claveEncriptacionTexto);
  txtBDMySQLContrasena2.Text := desencriptar (leCadINI('Base de datos', 'Contrasea', ''), claveEncriptacionTexto);
  txtMySQLProtocolo.Text := leCadINI('Base de datos', 'Protocolo', 'mysql4.1');
  txtMySQLPuerto.Text := leCadINI('Base de datos', 'Puerto', '3306');
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  esCadINI('Base de datos', 'Nombre BD', txtBDMySQLNombreBD.Text);
  esCadINI('Base de datos', 'Servidor', txtBDMySQLServidor.Text);
  esCadINI('Base de datos', 'Protocolo', txtMySQLProtocolo.Text);
  esCadINI('Base de datos', 'Puerto', txtMySQLPuerto.Text);
  esCadINI('Base de datos', 'Usuario', trim(encriptar (txtBDMySQLUsuario.Text, claveEncriptacionTexto)));
  esCadINI('Base de datos', 'Contrasea', trim(encriptar (txtBDMySQLContrasena.Text, claveEncriptacionTexto)));
end;

function extraerTipoDatos (tipo : string) : string;
begin
  Result := AnsiUpperCase(LeftStr(tipo, pos('(', tipo) - 1));
end;

function obtenerLikesSQL (campos : string; valor : string) : string;
begin
  
end;

function TformMenuPrincipal.obtenerCamposTexto (tabla : string) : TStringList;
var
  tipo, campo, clave, tipoSimple : string;
  camposTexto : TStringList;
begin
  camposTexto := TStringList.Create;
  tcCampos.Close;
  tcCampos.SQL.Clear;
  tcCampos.SQL.Add('desc ' + tabla);
  try
    tcCampos.Open;
    while not tcCampos.Eof do
    begin
      campo := tcCampos.fieldbyname('field').AsString;
      tipo := tcCampos.fieldbyname('type').AsString;
      clave := tcCampos.fieldbyname('key').AsString;
      tipoSimple := extraerTipoDatos (tipo);
      if (tipoSimple = 'VARCHAR') or
         (tipoSimple = 'TEXT') or
         (tipoSimple = 'CHAR') or
         (tipoSimple = 'BINARY') or
         (tipoSimple = 'VARBINARY') or
         (tipoSimple = 'TINYTEX') or
         (tipoSimple = 'MEDIUMTEXT') or
         (tipoSimple = 'LONGTEXT')or
         (tipoSimple = 'BLOB') or
         (tipoSimple = 'TINYBLOB') or
         (tipoSimple = 'MEDIUMBLOB') or
         (tipoSimple = 'LONGBLOB')  then
        camposTexto.Add(campo);
      tcCampos.Next;
    end;
    Result := camposTexto;
  except
    raise;
  end;
end;

procedure TformMenuPrincipal.btIniciarBusquedaClick(Sender: TObject);
var
  i : integer;
  tablaActual, consultaSQL : string;
  camposTablaTexto : TStringList;
begin
  numCoincidencias := 0;
  numTablas := 0;
  tabConexion.Show;
  if not bd.Connected then
  begin
    MessageDlg('Debe realizar la conexin con el servidor de MySQL.',
        mtInformation, [mbok], 0);
    btConectar.SetFocus;
  end
  else
  begin
    if txtValorBuscar.Text = '' then
    begin
      MessageDlg('Debe introducir el valor a buscar.',
          mtInformation, [mbok], 0);
      txtValorBuscar.SetFocus;
    end
    else
    begin
      if lsTablas.SelCount <= 0 then
      begin
        MessageDlg('Debe seleccionar las tablas en las que se realizar ' +
            'la bsqueda.', mtInformation, [mbok], 0);
        lsTablas.SetFocus;
      end
      else
      begin
        if MessageDlg('Est seguro que desea iniciar la bsqueda en ' +
            inttostr(lsTablas.SelCount) + ' tablas?',
            mtConfirmation, [mbno, mbyes], 0) = mryes then
        begin
          Screen.Cursor := crHourGlass;

          bp.Min := 0;
          bp.Max := lsTablas.SelCount -1;

          //eliminamos todas las pestaas actuales del TabTablas
          while tabTablas.PageCount > 0 do
            tabTablas.ActivePage.Free;

          //recorremos todas las tablas
          for i := 0 to lsTablas.Count - 1 do
          begin
            //ejecutamos consulta SQL slo para las seleccionadas
            if lsTablas.Selected[i] then
            begin
              bp.Position := i;
              tablaActual := lsTablas.Items[i];
              camposTablaTexto := obtenerCamposTexto (tablaActual);
              if (camposTablaTexto.Count > 0) then
              begin
                consultaSQL := obtenerSQLConsulta (camposTablaTexto, tablaActual, txtValorBuscar.Text);
                if consultaSQL <> '' then
                  crearTabTablas(tablaActual, consultaSQL);
              end;
            end;
          end;
          Screen.Cursor := crDefault;
          MessageDlg('Nmero de tablas con coincidencias: ' +
              IntToStr(numTablas) + chr(13) +
              'Nmero de coincidencias encontradas: ' +
              IntToStr(numCoincidencias), mtInformation, [mbok], 0);
          tabResultado.Show;
          tabResultado.Refresh;              
        end;
      end;
    end;
  end;
end;

procedure TformMenuPrincipal.FormShow(Sender: TObject);
begin
  tabConexion.Show;
  if (txtBDMySQLNombreBD.Text = '') or (txtBDMySQLServidor.Text = '') or
      (txtBDMySQLUsuario.Text = '') or (txtBDMySQLContrasena.Text = '') or
      (txtMySQLProtocolo.Text = '') or (txtMySQLPuerto.Text = '') then
    txtBDMySQLServidor.SetFocus
  else
    btConectar.SetFocus;
end;

end.
